# -*- coding: utf-8 -*-
import requests

rasppi_url="http://87577650.ap.ngrok.io"

## レスポンス返信用
def build_speechlet_response(output, reprompt_text, should_end_session):
    return {
        'outputSpeech': {
            'type': 'PlainText',
            'text': output
        },
        'reprompt': {
            'outputSpeech': {
                'type': 'PlainText',
                'text': reprompt_text
            }
        },
        'shouldEndSession': should_end_session
    }

def build_response(speechlet_response):
    return {
        'version': '1.0',
        'sessionAttributes': {},
        'response': speechlet_response
    }



## ユーザファンクション
def get_welcome_response():
    speech_output = "パイカメラで撮影するには、「写真をとって」と言ってください。"
    reprompt_text = None
    should_end_session = True
    return build_response(build_speechlet_response(speech_output, reprompt_text, should_end_session))


def handle_session_end_request():
    speech_output = None
    reprompt_text = None
    should_end_session = True
    return build_response(build_speechlet_response(speech_output, reprompt_text, should_end_session))


def publish():
    requests.get(rasppi_url)


def shutterr_on(session):
    should_end_session = True

    publish()
    
    speech_output = "撮影しました"
    reprompt_text = None
    return build_response(build_speechlet_response(speech_output, reprompt_text, should_end_session))


def on_session_started(session_started_request, session):
    print("on_session_started requestId=" + session_started_request['requestId'] + ", sessionId=" + session['sessionId'])


def on_launch(launch_request, session):
    print("on_launch requestId=" + launch_request['requestId'] + ", sessionId=" + session['sessionId'])
    return get_welcome_response()


def on_intent(intent_request, session):
    print("on_intent requestId=" + intent_request['requestId'] + ", sessionId=" + session['sessionId'])

    intent = intent_request['intent']
    intent_name = intent_request['intent']['name']

    if intent_name == "ShutterIntent":
        return shutterr_on(session)
    elif intent_name == "AMAZON.HelpIntent":
        return get_welcome_response()
    elif intent_name == "AMAZON.CancelIntent" or intent_name == "AMAZON.StopIntent":
        return handle_session_end_request()
    else:
        raise ValueError("Invalid intent")

def on_session_ended(session_ended_request, session):
    print("on_session_ended requestId=" + session_ended_request['requestId'] + ", sessionId=" + session['sessionId'])


def lambda_handler(event, context):
    print("event.session.application.applicationId=" + event['session']['application']['applicationId'])

    is_session_new = event['session']['new']
    request_type = event['request']['type']

    if is_session_new:
        on_session_started({'requestId': event['request']['requestId']}, event['session'])

    if request_type == "LaunchRequest":
        return on_launch(event['request'], event['session'])
    elif request_type == "IntentRequest":
        return on_intent(event['request'], event['session'])
    elif request_type == "SessionEndedRequest":
        return on_session_ended(event['request'], event['session'])

