import json
import falcon
import subprocess

def send_remocon(key='KEY_POWER'):
    subprocess.call(['irsend', 'SEND_ONCE', 'Sharp', key])
    print("irsend:", key)

class remoconResource(object):

    def on_post(self, req, resp):
        # postパラメーターを取得
        body = req.stream.read().decode('utf8').replace("'", '"')
        data = json.loads(body)

        # onoff
        onoff = data['result']['parameters']['user_says1']
        print("Request: ", onoff)
        if onoff == 'POWERON':
            send_remocon()
        elif onoff == 'POWEROFF':
            send_remocon()

        msg = {
            "speech": "テレビの電源を" + onoff + "しました",
            "displayText": "TVの電源を" + onoff + "しました。",
        }
        resp.body = json.dumps(msg)



app = falcon.API()
app.add_route("/", remoconResource())


if __name__ == "__main__":
    from wsgiref import simple_server
    httpd = simple_server.make_server("127.0.0.1", 8080, app)
    httpd.serve_forever()
