#!/usr/bin/env python3
import os
import socket
import subprocess
import time
import jtalk

host = '127.0.0.1'
port = 10500   # julius port

start_rcognize = 0

def get_param(args):
    param = str(subprocess.check_output(['vcgencmd'] + args)).split('=')
    return param[1][0:-3]

def process_query(sentence):
    global start_rcognize
    if start_rcognize == 0:
        if sentence == 'ヘイラズパイ':
            jtalk.jtalk('はい')
            start_rcognize = 1
    else:
        if sentence == 'ヘイラズパイ':
            print('do nothing')
        elif sentence in ['温度を教えて', '温度教えて']:
            temp = get_param(['measure_temp'])
            jtalk.jtalk('CPUの温度は' + temp[0:-2] + '度です')
            print(temp)
        elif sentence in ['クロックを教えて', 'クロック教えて']:
            clock = get_param(['measure_clock', 'arm'])
            jtalk.jtalk('CPUのクロックは' + str(int(clock) / 1000000) + 'メガヘルツです')
            print(clock)
        elif sentence in ['電圧を教えて', '電圧教えて']:
            volt = get_param(['measure_volts'])
            jtalk.jtalk('CPUの電圧は' + volt[0:-1] + 'ボルトです')
            print(volt)
        else:
            jtalk.jtalk('わかりません')
            print('わかりません')

def main():

    p = subprocess.Popen(["./julius-start.sh"], stdout=subprocess.PIPE, shell=True)
    pid = str(p.stdout.read().decode('utf-8'))
    time.sleep(3)
    client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client.connect((host, port))
    print('<<< please speak >>>')

    try:
        data = ''
        sentence = ''
        while 1:
            if '</RECOGOUT>\n.' in data: 
                word = ''
                for line in data.split('\n'):
                    index = line.find('WORD="')
                    if index != -1:
                        line = line[index + 6:line.find('"', index + 6)]
                        word = str(line)

                    if word != '[s]':
                        sentence += word

                print('"' + sentence + '"')
                process_query(sentence)
                sentence = ''
                data = ''
                print('<<< please speak >>>')

            else:
                data += str(client.recv(1024).decode('utf-8'))

    except KeyboardInterrupt:
        p.kill()
        subprocess.call(["kill " + pid], shell=True)
        client.close()

if __name__ == "__main__":
    main()

